﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

using FiltersDemo4Blog.Extensions;

namespace FiltersDemo4Blog.Controllers
{
    public class AuthFiltersController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        //[Authorize(Users = "a,bb,ccc")]
        [Authorize]
        public ActionResult Welcome()
        {
            ViewBag.Message = "普通已授权页面";
            return View();
        }

        [UserAuthorize(AuthorizationFailView = "Error")]   //管理员页面
        public ActionResult AdminUser()
        {
            ViewBag.Message = "管理员页面";
            return View("Welcome");
        }

        [UserAuthorize(AuthorizationFailView = "Error")]   //会员页面（管理员、会员都可访问）
        public ActionResult SeniorUser()
        {
            ViewBag.Message = "高级会员页面";
            return View("Welcome");
        }

        [UserAuthorize(AuthorizationFailView = "Error")]   //游客页面（管理员、会员、游客都可访问）
        public ActionResult JuniorUser()    //游客页面
        {
            ViewBag.Message = "初级会员页面";
            return View("Welcome");
        }

    }
}
