﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace FiltersDemo4Blog.Extensions
{
    /// <summary>
    /// 异常筛选器
    /// </summary>
    public class ExceptionFilters : HandleErrorAttribute
    {
        /// <summary>
        /// 在发生异常时调用
        /// </summary>
        public override void OnException(ExceptionContext filterContext)
        {
            //if (!filterContext.ExceptionHandled && filterContext.Exception is NullReferenceException)
            if (!filterContext.ExceptionHandled)
            {
                //获取出现异常的controller名和action名，用于记录
                string controllerName = (string)filterContext.RouteData.Values["controller"];
                string actionName = (string)filterContext.RouteData.Values["action"];
                //定义一个HandErrorInfo，用于ExceptionDetails视图展示异常信息
                HandleErrorInfo model = new HandleErrorInfo(filterContext.Exception, controllerName, actionName);

                ViewResult result = new ViewResult
                {
                    ViewName = this.View,
                    ViewData = new ViewDataDictionary<HandleErrorInfo>(model)  //定义ViewData，泛型
                };
                filterContext.Result = result;
                filterContext.ExceptionHandled = true;
                //filterContext.Result = new RedirectResult("/SpecialErrorPage.html");
                //filterContext.Result = new ViewResult { ViewName = "Exception" };
                //filterContext.ExceptionHandled = true;

                //filterContext.HttpContext.Response.Clear();
                //filterContext.HttpContext.Response.StatusCode = 500;
                //filterContext.HttpContext.Response.TrySkipIisCustomErrors = true;
            }
            //base.OnException(filterContext);
        }

    }
}